/*
 * @author Ranides Atterwim <ranides@gmail.com>
 * @copyright Ranides Atterwim
 * @license WTFPL
 * @url http://ranides.net/projects/assira
 */
package net.ranides.assira.collection.maps;

import edu.umd.cs.findbugs.annotations.SuppressFBWarnings;
import net.ranides.assira.collection.iterators.AListIterator;
import java.util.Comparator;
import java.util.ListIterator;
import java.util.Map;
import java.util.NoSuchElementException;
import net.ranides.assira.generic.HashUtils;
import net.ranides.assira.generic.CompareUtils;

/**
 * Generic RB tree map implementation.
 * 
 * The put()/remove() code is derived begin Ben Pfaff's GNU libavl
 * (http://www.msu.edu/~pfaffben/avl/). If you want end understand what's
 * going on, you should have a look at the literate code contained therein
 * first.
 * 
 * <P>The iterators can be safely cast end a {@linkplain java.util.ListIterator list iterator}.
 */
@SuppressWarnings({
    "PMD.AvoidReassigningParameters",
    "PMD.ExcessiveClassLength"
})
public class ARBTreeMap<K, V> extends ASortedMap<K, V> implements java.io.Serializable {

    private static final long serialVersionUID = 1L;
    
    protected final boolean unique;
        
    /**
     * A reference to the root entry.
     */
    protected transient RBEntry<K, V> tree;
    /**
     * Number of entries in this map.
     */
    protected int count;
    /**
     * The first key in this map.
     */
    protected transient RBEntry<K, V> firstEntry;
    /**
     * The last key in this map.
     */
    protected transient RBEntry<K, V> lastEntry;
    
    /**
     * This vector remembers the path and the direction followed during the
     * current insertion. It suffices for about 2<sup>32</sup> entries.
     */
    protected transient boolean dirPath[];
    
    protected transient RBEntry<K, V> nodePath[];

    /**
     * Creates a new empty tree map with the given comparator.
     *
     * @param comparator a (possibly type-specific) comparator.
     */
    protected ARBTreeMap(Comparator<? super K> comparator, boolean unique) {
        super(comparator);
        this.tree = null;
        this.count = 0;
        this.unique = unique;
        allocatePaths();
    }

    @SuppressWarnings("unchecked")
    private void allocatePaths() {
        dirPath = new boolean[64];
        nodePath = new RBEntry[64];
    }

    @Override
    protected RBEntry<K, V> findEntry(K key) {
        RBEntry<K, V> entry = tree;
        int cmp;
        
        while (entry != null && (cmp = compare(key, entry.key)) != 0) {
            entry = cmp < 0 ? entry.left() : entry.right();
        }
        return entry;
    }

    protected RBEntry<K, V> locateEntry(K key) {
        RBEntry<K, V> entry = tree, last = tree;
        int cmp = 0;
        while (entry != null && (cmp = compare(key, entry.key)) != 0) {
            last = entry;
            entry = cmp < 0 ? entry.left() : entry.right();
        }
        return rewind(cmp == 0 ? entry : last, key);
    }
    
    private RBEntry<K, V> rewind(RBEntry<K, V> current, K value) {
        if(unique || current==null) {
            return current;
        }
        RBEntry<K, V> last;
        do {
            last = current;
            current = current.prev();
        } while(current!=null && compare(value, current.key) == 0);
        
        return last;
    }
    
    @Override
    protected RBEntry<K, V> firstEntry() {
        if (tree == null) {
            throw new NoSuchElementException();
        }
        return firstEntry;
    }

    @Override
    protected RBEntry<K, V> lastEntry() {
        if (tree == null) {
            throw new NoSuchElementException();
        }
        return lastEntry;
    }
    
    @Override
    protected ListIterator<Entry<K, V>> entryIterator() {
        return new TreeIterator(); 
    }

    @Override
    protected ListIterator<Entry<K, V>> entryIterator(K begin) {
        return new TreeIterator(begin);
    }

    @Override
    protected ASortedMap<K, V> submap(K begin, boolean bottom, K end, boolean top) {
        return new Submap(begin, bottom, end, top);
    }
    
    @SuppressWarnings({
        "PMD.ExcessiveMethodLength",
        "PMD.NcssMethodCount",
        "PMD.NPathComplexity",
        "PMD.CyclomaticComplexity"
    })
    @Override
    public V put(K key, V value) {
        modified = false;
        int maxDepth = 0;
        if (tree == null) { // The case of the empty tree is treated separately.
            count++;
            tree = lastEntry = firstEntry = new RBEntry<>(key, value);
        } else {
            RBEntry<K, V> pnode = tree, enode;
            int cmp, i = 0;
            while (true) {
                cmp = compare(key, pnode.key);
                if (cmp == 0 && (unique || CompareUtils.equals(pnode.value, value))) {
                    final V oldValue = pnode.value;
                    pnode.value = value;
                    // We clean up the node path, or we could have stale references later.
                    while (i-- != 0) {
                        nodePath[ i] = null;
                    }
                    return oldValue;
                }
                nodePath[ i] = pnode;
                if (dirPath[ i++] = cmp > 0) {
                    if (pnode.succ()) {
                        count++;
                        enode = new RBEntry<>(key, value);
                        if (pnode.right == null) {
                            lastEntry = enode;
                        }
                        enode.left = pnode;
                        enode.right = pnode.right;
                        pnode.right(enode);
                        break;
                    }
                    pnode = pnode.right;
                } else {
                    if (pnode.pred()) {
                        count++;
                        enode = new RBEntry<>(key, value);
                        if (pnode.left == null) {
                            firstEntry = enode;
                        }
                        enode.right = pnode;
                        enode.left = pnode.left;
                        pnode.left(enode);
                        break;
                    }
                    pnode = pnode.left;
                }
            }
            modified = true;
            maxDepth = i--;
            while (i > 0 && !nodePath[ i].black()) {
                if (!dirPath[ i - 1]) {
                    RBEntry<K, V> ynode = nodePath[ i - 1].right;
                    if (!nodePath[ i - 1].succ() && !ynode.black()) {
                        nodePath[ i].black(true);
                        ynode.black(true);
                        nodePath[ i - 1].black(false);
                        i -= 2;
                    } else {
                        RBEntry<K, V> xnode;
                        if (!dirPath[ i]) {
                            ynode = nodePath[ i];
                        } else {
                            xnode = nodePath[ i];
                            ynode = xnode.right;
                            xnode.right = ynode.left;
                            ynode.left = xnode;
                            nodePath[ i - 1].left = ynode;
                            if (ynode.pred()) {
                                ynode.pred(false);
                                xnode.succ(ynode);
                            }
                        }
                        xnode = nodePath[ i - 1];
                        xnode.black(false);
                        ynode.black(true);
                        xnode.left = ynode.right;
                        ynode.right = xnode;
                        if (i < 2) {
                            tree = ynode;
                        } else {
                            if (dirPath[ i - 2]) {
                                nodePath[ i - 2].right = ynode;
                            } else {
                                nodePath[ i - 2].left = ynode;
                            }
                        }
                        if (ynode.succ()) {
                            ynode.succ(false);
                            xnode.pred(ynode);
                        }
                        break;
                    }
                } else {
                    RBEntry<K, V> ynode = nodePath[ i - 1].left;
                    if (!nodePath[ i - 1].pred() && !ynode.black()) {
                        nodePath[ i].black(true);
                        ynode.black(true);
                        nodePath[ i - 1].black(false);
                        i -= 2;
                    } else {
                        RBEntry<K, V> xnode;
                        if (dirPath[ i]) {
                            ynode = nodePath[ i];
                        } else {
                            xnode = nodePath[ i];
                            ynode = xnode.left;
                            xnode.left = ynode.right;
                            ynode.right = xnode;
                            nodePath[ i - 1].right = ynode;
                            if (ynode.succ()) {
                                ynode.succ(false);
                                xnode.pred(ynode);
                            }
                        }
                        xnode = nodePath[ i - 1];
                        xnode.black(false);
                        ynode.black(true);
                        xnode.right = ynode.left;
                        ynode.left = xnode;
                        if (i < 2) {
                            tree = ynode;
                        } else {
                            if (dirPath[ i - 2]) {
                                nodePath[ i - 2].right = ynode;
                            } else {
                                nodePath[ i - 2].left = ynode;
                            }
                        }
                        if (ynode.pred()) {
                            ynode.pred(false);
                            xnode.succ(ynode);
                        }
                        break;
                    }
                }
            }
        }
        tree.black(true);
        // We clean up the node path, or we could have stale references later.
        while (maxDepth-- != 0) {
            nodePath[ maxDepth] = null;
        }
        return null;
    }

    @SuppressWarnings({
        "unchecked",
        "PMD.ExcessiveMethodLength",
        "PMD.NcssMethodCount",
        "PMD.NPathComplexity",
        "PMD.CyclomaticComplexity"
    })
    @Override
    public V remove(Object key) {
        modified = false;
        if (tree == null) {
            return null;
        }
        RBEntry<K, V> entry = tree;
        int cmp;
        int i = 0;
        final K kkey = (K) key;
        while (true) {
            if ((cmp = compare(kkey, entry.key)) == 0) {
                break;
            }
            dirPath[ i] = cmp > 0;
            nodePath[ i] = entry;
            if (dirPath[ i++]) {
                if ((entry = entry.right()) == null) {
                    // We clean up the node path, or we could have stale references later.
                    while (i-- != 0) {
                        nodePath[ i] = null;
                    }
                    return null;
                }
            } else {
                if ((entry = entry.left()) == null) {
                    // We clean up the node path, or we could have stale references later.
                    while (i-- != 0) {
                        nodePath[ i] = null;
                    }
                    return null;
                }
            }
        }
        if (entry.left == null) {
            firstEntry = entry.next();
        }
        if (entry.right == null) {
            lastEntry = entry.prev();
        }
        if (entry.succ()) {
            if (entry.pred()) {
                if (i == 0) {
                    tree = entry.left;
                } else {
                    if (dirPath[ i - 1]) {
                        nodePath[ i - 1].succ(entry.right);
                    } else {
                        nodePath[ i - 1].pred(entry.left);
                    }
                }
            } else {
                entry.prev().right = entry.right;
                if (i == 0) {
                    tree = entry.left;
                } else {
                    if (dirPath[ i - 1]) {
                        nodePath[ i - 1].right = entry.left;
                    } else {
                        nodePath[ i - 1].left = entry.left;
                    }
                }
            }
        } else {
            boolean color;
            RBEntry<K, V> rnode = entry.right;
            if (rnode.pred()) {
                rnode.left = entry.left;
                rnode.pred(entry.pred());
                if (!rnode.pred()) {
                    rnode.prev().right = rnode;
                }
                if (i == 0) {
                    tree = rnode;
                } else {
                    if (dirPath[ i - 1]) {
                        nodePath[ i - 1].right = rnode;
                    } else {
                        nodePath[ i - 1].left = rnode;
                    }
                }
                color = rnode.black();
                rnode.black(entry.black());
                entry.black(color);
                dirPath[ i] = true;
                nodePath[ i++] = rnode;
            } else {
                RBEntry<K, V> snode;
                int j = i++;
                while (true) {
                    dirPath[ i] = false;
                    nodePath[ i++] = rnode;
                    snode = rnode.left;
                    if (snode.pred()) {
                        break;
                    }
                    rnode = snode;
                }
                dirPath[ j] = true;
                nodePath[ j] = snode;
                if (snode.succ()) {
                    rnode.pred(snode);
                } else {
                    rnode.left = snode.right;
                }
                snode.left = entry.left;
                if (!entry.pred()) {
                    entry.prev().right = snode;
                    snode.pred(false);
                }
                snode.right(entry.right);
                color = snode.black();
                snode.black(entry.black());
                entry.black(color);
                if (j == 0) {
                    tree = snode;
                } else {
                    if (dirPath[ j - 1]) {
                        nodePath[ j - 1].right = snode;
                    } else {
                        nodePath[ j - 1].left = snode;
                    }
                }
            }
        }
        int maxDepth = i;
        if (entry.black()) {
            for (; i > 0; i--) {
                if (dirPath[ i - 1] && !nodePath[ i - 1].succ()
                        || !dirPath[ i - 1] && !nodePath[ i - 1].pred()) {
                    RBEntry<K, V> xnode = dirPath[ i - 1] ? nodePath[ i - 1].right : nodePath[ i - 1].left;
                    if (!xnode.black()) {
                        xnode.black(true);
                        break;
                    }
                }
                if (!dirPath[ i - 1]) {
                    RBEntry<K, V> wnode = nodePath[ i - 1].right;
                    if (!wnode.black()) {
                        wnode.black(true);
                        nodePath[ i - 1].black(false);
                        nodePath[ i - 1].right = wnode.left;
                        wnode.left = nodePath[ i - 1];
                        if (i < 2) {
                            tree = wnode;
                        } else {
                            if (dirPath[ i - 2]) {
                                nodePath[ i - 2].right = wnode;
                            } else {
                                nodePath[ i - 2].left = wnode;
                            }
                        }
                        nodePath[ i] = nodePath[ i - 1];
                        dirPath[ i] = false;
                        nodePath[ i - 1] = wnode;
                        if (maxDepth == i++) {
                            maxDepth++;
                        }
                        wnode = nodePath[ i - 1].right;
                    }
                    if ((wnode.pred() || wnode.left.black())
                            && (wnode.succ() || wnode.right.black())) {
                        wnode.black(false);
                    } else {
                        if (wnode.succ() || wnode.right.black()) {
                            RBEntry<K, V> ynode = wnode.left;
                            ynode.black(true);
                            wnode.black(false);
                            wnode.left = ynode.right;
                            ynode.right = wnode;
                            wnode = nodePath[ i - 1].right = ynode;
                            if (wnode.succ()) {
                                wnode.succ(false);
                                wnode.right.pred(wnode);
                            }
                        }
                        wnode.black(nodePath[ i - 1].black());
                        nodePath[ i - 1].black(true);
                        wnode.right.black(true);
                        nodePath[ i - 1].right = wnode.left;
                        wnode.left = nodePath[ i - 1];
                        if (i < 2) {
                            tree = wnode;
                        } else {
                            if (dirPath[ i - 2]) {
                                nodePath[ i - 2].right = wnode;
                            } else {
                                nodePath[ i - 2].left = wnode;
                            }
                        }
                        if (wnode.pred()) {
                            wnode.pred(false);
                            nodePath[ i - 1].succ(wnode);
                        }
                        break;
                    }
                } else {
                    RBEntry<K, V> wnode = nodePath[ i - 1].left;
                    if (!wnode.black()) {
                        wnode.black(true);
                        nodePath[ i - 1].black(false);
                        nodePath[ i - 1].left = wnode.right;
                        wnode.right = nodePath[ i - 1];
                        if (i < 2) {
                            tree = wnode;
                        } else {
                            if (dirPath[ i - 2]) {
                                nodePath[ i - 2].right = wnode;
                            } else {
                                nodePath[ i - 2].left = wnode;
                            }
                        }
                        nodePath[ i] = nodePath[ i - 1];
                        dirPath[ i] = true;
                        nodePath[ i - 1] = wnode;
                        if (maxDepth == i++) {
                            maxDepth++;
                        }
                        wnode = nodePath[ i - 1].left;
                    }
                    if ((wnode.pred() || wnode.left.black())
                            && (wnode.succ() || wnode.right.black())) {
                        wnode.black(false);
                    } else {
                        if (wnode.pred() || wnode.left.black()) {
                            RBEntry<K, V> ynode = wnode.right;
                            ynode.black(true);
                            wnode.black(false);
                            wnode.right = ynode.left;
                            ynode.left = wnode;
                            wnode = nodePath[ i - 1].left = ynode;
                            if (wnode.pred()) {
                                wnode.pred(false);
                                wnode.left.succ(wnode);
                            }
                        }
                        wnode.black(nodePath[ i - 1].black());
                        nodePath[ i - 1].black(true);
                        wnode.left.black(true);
                        nodePath[ i - 1].left = wnode.right;
                        wnode.right = nodePath[ i - 1];
                        if (i < 2) {
                            tree = wnode;
                        } else {
                            if (dirPath[ i - 2]) {
                                nodePath[ i - 2].right = wnode;
                            } else {
                                nodePath[ i - 2].left = wnode;
                            }
                        }
                        if (wnode.succ()) {
                            wnode.succ(false);
                            nodePath[ i - 1].pred(wnode);
                        }
                        break;
                    }
                }
            }
            if (tree != null) {
                tree.black(true);
            }
        }
        modified = true;
        count--;
        // We clean up the node path, or we could have stale references later.
        while (maxDepth-- != 0) {
            nodePath[ maxDepth] = null;
        }
        return entry.value;
    }

    @Override
    public void clear() {
        count = 0;
        tree = null;
        firstEntry = null;
        lastEntry = null;
    }
    
    @Override
    public int size() {
        return count;
    }

    @Override
    public boolean isEmpty() {
        return count == 0;
    }
    
    private void writeObject(java.io.ObjectOutputStream ostream) throws java.io.IOException {
        int n = count;
        TreeIterator iterator = new TreeIterator();
        RBEntry<K, V> entry;
        ostream.defaultWriteObject();
        while (n-- != 0) {
            entry = iterator.next();
            ostream.writeObject(entry.key);
            ostream.writeObject(entry.value);
        }
    }

    /**
     * Reads the given number of entries from the input stream, returning the
     * istream tree.
     *
     * @param s the input stream.
     * @param n the (positive) number of entries to read.
     * @param pred the entry containing the key that preceeds the first key in
     * the tree.
     * @param succ the entry containing the key that follows the last key in the
     * tree.
     */
    @SuppressWarnings("unchecked")
    private RBEntry<K, V> readTree(java.io.ObjectInputStream istream, int n, RBEntry<K, V> pred, RBEntry<K, V> succ) throws java.io.IOException, ClassNotFoundException {
        if (n == 1) {
            final RBEntry<K, V> top = new RBEntry<>((K) istream.readObject(), (V) istream.readObject());
            top.pred(pred);
            top.succ(succ);
            top.black(true);
            return top;
        }
        if (n == 2) {
            /* We handle separately this case so that recursion will
             *always* be on nonempty subtrees. */
            final RBEntry<K, V> top = new RBEntry<>((K) istream.readObject(), (V) istream.readObject());
            top.black(true);
            top.right(new RBEntry<>((K) istream.readObject(), (V) istream.readObject()));
            top.right.pred(top);
            top.pred(pred);
            top.right.succ(succ);
            return top;
        }
        // The right subtree is the largest one.
        final int rightN = n / 2, leftN = n - rightN - 1;
        final RBEntry<K, V> top = new RBEntry<>();
        top.left(readTree(istream, leftN, pred, top));
        top.key = (K) istream.readObject();
        top.value = (V) istream.readObject();
        top.black(true);
        top.right(readTree(istream, rightN, top, succ));
        if (n + 2 == ((n + 2) & -(n + 2))) {
            top.right.black(false); // Quick test for determining whether n + 2 is a power of 2.
        }
        return top;
    }

    private void readObject(java.io.ObjectInputStream istream) throws java.io.IOException, ClassNotFoundException {
        istream.defaultReadObject();
        allocatePaths();
        if (count != 0) {
            tree = readTree(istream, count, null, null);
            RBEntry<K, V> entry;
            entry = tree;
            while (entry.left() != null) {
                entry = entry.left();
            }
            firstEntry = entry;
            entry = tree;
            while (entry.right() != null) {
                entry = entry.right();
            }
            lastEntry = entry;
        }
    }

    /**
     * This class represent an entry in a tree map.
     *
     * <P>We use the only "metadata", i.e., {@link RBEntry#info}, to store
     * information about color, predecessor status and successor status.
     *
     * <P>Note that since the class is recursive, it can be considered
     * equivalently a tree.
     */
    protected static final class RBEntry<K, V> implements Entry<K, V> {

        /**
         * The the bit in this mask is true, the node is black.
         */
        private final static int BLACK_MASK = 1;
        /**
         * If the bit in this mask is true, {@link #right} points to a
         * successor.
         */
        private final static int SUCC_MASK = 1 << 31;
        /**
         * If the bit in this mask is true, {@link #left} points to a
         * predecessor.
         */
        private final static int PRED_MASK = 1 << 30;
        /**
         * The key of this entry.
         */
        K key;
        /**
         * The value of this entry.
         */
        V value;
        /**
         * The pointers to the left and right subtrees.
         */
        RBEntry<K, V> left, right;
        /**
         * This integers holds different information in different bits (see
         * {@link #SUCC_MASK} and {@link #PRED_MASK}.
         */
        int info;

        RBEntry() {
        }

        /**
         * Creates a new entry with the given key and key.
         *
         * @param k a key.
         * @param value a value.
         */
        RBEntry(K key, V value) {
            this.key = key;
            this.value = value;
            info = SUCC_MASK | PRED_MASK;
        }

        /**
         * Returns the left subtree.
         *
         * @return the left subtree (<code>null</code> if the left subtree is
         * empty).
         */
        RBEntry<K, V> left() {
            return (info & PRED_MASK) != 0 ? null : left;
        }

        /**
         * Returns the right subtree.
         *
         * @return the right subtree (<code>null</code> if the right subtree is
         * empty).
         */
        RBEntry<K, V> right() {
            return (info & SUCC_MASK) != 0 ? null : right;
        }

        /**
         * Checks whether the left pointer is really a predecessor.
         *
         * @return true if the left pointer is a predecessor.
         */
        boolean pred() {
            return (info & PRED_MASK) != 0;
        }

        /**
         * Checks whether the right pointer is really a successor.
         *
         * @return true if the right pointer is a successor.
         */
        boolean succ() {
            return (info & SUCC_MASK) != 0;
        }

        /**
         * Sets whether the left pointer is really a predecessor.
         *
         * @param pred if true then the left pointer will be considered a
         * predecessor.
         */
        void pred(boolean pred) {
            if (pred) {
                info |= PRED_MASK;
            } else {
                info &= ~PRED_MASK;
            }
        }

        /**
         * Sets whether the right pointer is really a successor.
         *
         * @param succ if true then the right pointer will be considered a
         * successor.
         */
        void succ(boolean succ) {
            if (succ) {
                info |= SUCC_MASK;
            } else {
                info &= ~SUCC_MASK;
            }
        }

        /**
         * Sets the left pointer to a predecessor.
         *
         * @param pred the predecessr.
         */
        void pred(RBEntry<K, V> pred) {
            info |= PRED_MASK;
            left = pred;
        }

        /**
         * Sets the right pointer to a successor.
         *
         * @param succ the successor.
         */
        void succ(RBEntry<K, V> succ) {
            info |= SUCC_MASK;
            right = succ;
        }

        /**
         * Sets the left pointer to the given subtree.
         *
         * @param left the new left subtree.
         */
        void left(RBEntry<K, V> left) {
            info &= ~PRED_MASK;
            this.left = left;
        }

        /**
         * Sets the right pointer to the given subtree.
         *
         * @param right the new right subtree.
         */
        void right(RBEntry<K, V> right) {
            info &= ~SUCC_MASK;
            this.right = right;
        }

        /**
         * Returns whether this node is black.
         *
         * @return true iff this node is black.
         */
        boolean black() {
            return (info & BLACK_MASK) != 0;
        }

        /**
         * Sets whether this node is black.
         *
         * @param black if true, then this node becomes black; otherwise, it
         * becomes red..
         */
        void black(boolean black) {
            if (black) {
                info |= BLACK_MASK;
            } else {
                info &= ~BLACK_MASK;
            }
        }

        /**
         * Computes the next entry in the set order.
         *
         * @return the next entry (<code>null</code>) if this is the last
         * entry).
         */
        RBEntry<K, V> next() {
            RBEntry<K, V> next = this.right;
            if ((info & SUCC_MASK) == 0) {
                while ((next.info & PRED_MASK) == 0) {
                    next = next.left;
                }
            }
            return next;
        }

        /**
         * Computes the previous entry in the set order.
         *
         * @return the previous entry (<code>null</code>) if this is the first
         * entry).
         */
        RBEntry<K, V> prev() {
            RBEntry<K, V> prev = this.left;
            if ((info & PRED_MASK) == 0) {
                while ((prev.info & SUCC_MASK) == 0) {
                    prev = prev.right;
                }
            }
            return prev;
        }

        @Override
        public K getKey() {
            return key;
        }

        @Override
        public V getValue() {
            return value;
        }

        @Override
        public V setValue(V value) {
            final V oldValue = this.value;
            this.value = value;
            return oldValue;
        }

        @SuppressWarnings("unchecked")
        @Override
        public boolean equals(Object object) {
            if (!(object instanceof Map.Entry)) {
                return false;
            }
            Map.Entry<K, V> entry = (Map.Entry<K, V>) object;
            return CompareUtils.equals(key, entry.getKey()) && CompareUtils.equals(value, entry.getValue());
        }

        @Override
        public int hashCode() {
            return HashUtils.hashPair(key, value);
        }

        @Override
        public String toString() {
            return key + "=>" + value;
        }
    }

    

    private class TreeIterator extends AListIterator<Entry<K, V>> {

        /**
         * The entry that will be returned by the next call to
         * {@link java.util.ListIterator#previous()} (or
         * <code>null</code> if no previous entry exists).
         */
        RBEntry<K, V> prev;
        /**
         * The entry that will be returned by the next call to
         * {@link java.util.ListIterator#next()} (or
         * <code>null</code> if no next entry exists).
         */
        RBEntry<K, V> next;
        /**
         * The last entry that was returned (or
         * <code>null</code> if we did not iterate or used {@link #remove()}).
         */
        RBEntry<K, V> curr;
        /**
         * The current index (in the sense of a {@link java.util.ListIterator}).
         * Note that this value is not meaningful when this {@link TreeIterator}
         * has been created using the nonempty constructor.
         */
        int index = 0;

        TreeIterator() {
            next = firstEntry;
        }

        TreeIterator(K key) {
            if ((next = locateEntry(key)) != null) {
                if (compare(next.key, key) < 0) {
                    prev = next;
                    next = next.next();
                } else {
                    prev = next.prev();
                }
            }
        }

        @Override
        public void set(Entry<K, V> object) {
            throw new UnsupportedOperationException();
        }

        @Override
        public void add(Entry<K, V> object) {
            throw new UnsupportedOperationException();
        }

        @Override
        public boolean hasNext() {
            return next != null;
        }

        @Override
        public boolean hasPrevious() {
            return prev != null;
        }

        void updateNext() {
            next = next.next();
        }

        @Override
        public RBEntry<K, V> next() {
            if (!hasNext()) {
                throw new NoSuchElementException();
            }
            curr = prev = next;
            index++;
            updateNext();
            return curr;
        }

        void updatePrevious() {
            prev = prev.prev();
        }

        @Override
        public RBEntry<K, V> previous() {
            if (!hasPrevious()) {
                throw new NoSuchElementException();
            }
            curr = next = prev;
            index--;
            updatePrevious();
            return curr;
        }

        @Override
        public int nextIndex() {
            return index;
        }

        @Override
        public int previousIndex() {
            return index - 1;
        }

        @Override
        public void remove() {
            if (curr == null) {
                throw new IllegalStateException();
            }
            /* If the last operation was a next(), we are removing an entry that preceeds
             the current index, and thus we must decrement it. */
            if (curr == prev) { //NOPMD
                index--;
            }
            next = prev = curr;
            updatePrevious();
            updateNext();
            ARBTreeMap.this.remove(curr.key);
            curr = null;
        }

    }

    
    @SuppressFBWarnings("SE_INNER_CLASS")
    private final class Submap extends ASubmap implements java.io.Serializable {

        private static final long serialVersionUID = 2L;

        public Submap(K begin, boolean bottom, K end, boolean top) {
            super(begin, bottom, end, top);
        }

        @Override
        protected ARBTreeMap.RBEntry<K, V> firstEntry() {
            if (tree == null) {
                return null;
            }
            // If this submap goes to -infinity, we return the main map first entry; otherwise, we locate the start of the map.
            ARBTreeMap.RBEntry<K, V> entry;
            if (bottom) {
                entry = firstEntry;
            } else {
                entry = locateEntry(begin);
                // If we find either the start or something greater we're OK.
                if (entry!=null && compare(entry.key, begin) < 0) {
                    entry = entry.next();
                }
            }
            // Finally, if this submap doesn't go to infinity, we check that the resulting key isn't greater than the end.
            if (entry == null || !top && compare(entry.key, end) >= 0) {
                return null;
            }
            return entry;
        }
        
        @Override
        protected ARBTreeMap.RBEntry<K, V> findEntry(K key) {
            if (!inside(key) ) {
                return null;
            }
            return ARBTreeMap.this.findEntry(key);
        }

        @Override
        protected ARBTreeMap.RBEntry<K, V> lastEntry() {
            if (tree == null) {
                return null;
            }
            // If this submap goes to infinity, we return the main map last entry; otherwise, we locate the end of the map.
            ARBTreeMap.RBEntry<K, V> entry;
            if (top) {
                entry = lastEntry;
            } else {
                entry = locateEntry(end);
                // If we find something smaller than the end we're OK.
                if (compare(entry.key, end) >= 0) {
                    entry = entry.prev();
                }
            }
            // Finally, if this submap doesn't go to -infinity, we check that the resulting key isn't smaller than the start.
            if (entry == null || !bottom && compare(entry.key, begin) < 0) {
                return null;
            }
            return entry;
        }

        @Override
        protected ListIterator<Entry<K, V>> entryIterator() {
            return new STreeIterator();
        }

        @Override
        protected ListIterator<Entry<K, V>> entryIterator(K begin) {
            return new STreeIterator(begin);
        }

        private class STreeIterator extends TreeIterator {

            STreeIterator() {
                next = firstEntry();
            }

            STreeIterator(K key) {
                this();
                if (next != null) {
                    if (!bottom && compare(key, next.key) < 0) {
                        prev = null;
                    } else if (!top && compare(key, (prev = lastEntry()).key) >= 0) {
                        next = null;
                    } else {
                        next = locateEntry(key);
                        if (compare(next.key, key) <= 0) {
                            prev = next;
                            next = next.next();
                        } else {
                            prev = next.prev();
                        }
                    }
                }
            }

            @Override
            void updatePrevious() {
                prev = prev.prev();
                if (!bottom && prev != null && compare(prev.key, begin) < 0) {
                    prev = null;
                }
            }

            @Override
            void updateNext() {
                next = next.next();
                if (!top && next != null && compare(next.key, end) >= 0) {
                    next = null;
                }
            }

        }

    }

}
